kind: pipeline # 定义对象类型，还有secret和signature两种类型
type: docker # 定义流水线类型，还有kubernetes、exec、ssh等类型
name: veterans_client_web # 定义流水线名称

steps: # 定义流水线执行步骤，这些步骤将顺序执行
  - name: package # 流水线名称
    image: node:14.17.4-stretch-slim # 定义创建容器的Docker镜像
    volumes: #将容器内目录挂载到宿主机，仓库需要开启Trusted设置
      - name: node-cache
        path: /drone/src/node_modules
      - name: node-build
        path: /tmp
    commands: # 定义在Docker容器中执行的shell命令
      - npm install --registry=https://registry.npmmirror.com/
      - npm run build:test
      - mkdir -p /tmp/veterans_client_web/test-dist
      - cp -r test-dist/* /tmp/veterans_client_web/test-dist

  - name: build-start
    image: appleboy/drone-ssh # SSH工具镜像
    settings:
      host: 172.16.90.64 # 远程连接地址
      username: root # 远程连接账号
      password:
        from_secret: 64_ssh_pw # 从Secret中读取SSH密码
      port: 22 # 远程连接端口
      command_timeout: 5m # 远程执行命令超时时间
      script:
        - mv /www/wwwroot/vetergatewayweb.hw.hongweisoft.com/chat /tmp/
        - mv /www/wwwroot/vetergatewayweb.hw.hongweisoft.com/ /tmp/$(uuidgen)
        - mkdir -p /www/wwwroot/vetergatewayweb.hw.hongweisoft.com
        - mv /tmp/chat /www/wwwroot/vetergatewayweb.hw.hongweisoft.com/
        - cp -r /mydata/node/build/veterans_client_web/test-dist/* /www/wwwroot/vetergatewayweb.hw.hongweisoft.com # 进入宿主机构建目录

volumes:
  # 定义流水线挂载目录,用于共享数据
  - name: node-cache
    host:
      path: /mydata/node/cache/14/
  - name: node-build
    # 从宿主机中挂载的目录
    host:
      path: /mydata/node/build
